=== linux/packages/ubuntu-20.04/debian/changelog ===
audacity (3.0.3-1) UNRELEASED; urgency=medium

  * Initial release. (Closes: #XXXXXX)

 -- Dmitry Vedenko <dvedenko@ubuntu>  Mon, 02 Aug 2021 14:55:02 +0300
