=== linux/packages/ubuntu-20.04/debian/control ===
Source: audacity
Section: sound
Priority: optional
Maintainer:
Uploaders: 
Standards-Version: 4.5.0
Build-Depends: cmake,
               debhelper-compat (= 12),
               gettext,
               git,
               libgtk2.0-dev,
               libasound2-dev,
               libavformat-dev,
               libjack-jackd2-dev,
               zlib1g-dev,
               libexpat1-dev,
               libmp3lame-dev,
               libsndfile-dev,
               libsoxr-dev,
               portaudio19-dev,
               libsqlite3-dev,
               libavcodec-dev,
               libavformat-dev,
               libavutil-dev,
               libid3tag0-dev,
               libmad0-dev,
               libvamp-hostsdk3v5,
               libogg-dev,
               libvorbis-dev,
               libopus-dev,
               libflac-dev,
               libflac++-dev,
               lv2-dev,
               liblilv-dev,
               libserd-dev,
               libsord-dev,
               libsratom-dev,
               libsuil-dev,
               libportmidi-dev,
               libportsmf-dev,
               libsbsms-dev,
               libsoundtouch-dev,
               libtwolame-dev,
               libpng-dev,
               libjpeg-turbo8-dev
Homepage: https://www.audacityteam.org/
Rules-Requires-Root: no

Package: audacity
Architecture: amd64
Depends: ${misc:Depends},
         ${shlibs:Depends}
Description: Audacity is a multi-track audio editor for Linux/Unix, MacOS and
 Windows.
